//
//  CSDatabaseItem.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 15.05.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>


enum CSDatabaseItemType
{
    CSDB_BASE,
    
    CSDB_RELEASE,
    CSDB_SCENER,
    CSDB_GROUP,
    CSDB_EVENT
};


@class CSDatabaseItem;


@protocol CSDatabaseItemDelegate <NSObject>

- (void) databaseItemIsCached:(CSDatabaseItem*)item;
- (void) cachingFailed;

@end


@interface CSDatabaseItem : NSObject
{
    id<CSDatabaseItemDelegate>  _owner;
    
    NSMutableData*              _data;
    NSURLConnection*            _urlConnection;
}


@property (nonatomic) NSString* identifier;
@property NSUInteger cached_depth;
@property NSUInteger requested_depth;


- (id) initWithIdentifier:(NSString*)identifier;
- (void) cacheAndNotify:(id)owner withDepth:(NSUInteger)depth;

- (void) setFromXMLData:(NSData*)xmlData;

- (CSDatabaseItemType) type;

@end
