//
//  CSGroupItem.m
//  C64SceneBrowser
//
//  Created by Andreas Varga on 30.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "CSGroupItem.h"
#import "CSDatabaseCache.h"
#import "NSString+HTML.h"

@implementation CSGroupItem


@synthesize name = _name;
@synthesize website = _website;


// ----------------------------------------------------------------------------
- (id)init
// ----------------------------------------------------------------------------
{
    self = [super init];
    if (self)
    {
        _name = nil;
        _website = nil;
    }
    return self;
}


// ----------------------------------------------------------------------------
- (id) initWithGroupId:(NSString*)groupId
// ----------------------------------------------------------------------------
{
    self = [super initWithIdentifier:groupId];
    if (self)
    {
        _name = nil;
        _website = nil;
    }
    return self;
}


// ----------------------------------------------------------------------------
- (CSDatabaseItemType) type
// ----------------------------------------------------------------------------
{
    return CSDB_GROUP;
}


// ----------------------------------------------------------------------------
- (id) initWithXMLElement:(TBXMLElement*)groupElement
// ----------------------------------------------------------------------------
{
    self = [self init];
    if (self)
    {
        self = [self setFromXMLElement:groupElement];
    }
    return self;
}


// ----------------------------------------------------------------------------
- (id) setFromXMLElement:(TBXMLElement*)groupElement
// ----------------------------------------------------------------------------
{
    TBXMLElement* groupIdElement = [TBXML childElementNamed:@"ID" parentElement:groupElement];
    if (groupIdElement != NULL)
        self.identifier = [TBXML textForElement:groupIdElement];
    
    if (self.identifier != nil)
    {
        CSGroupItem* existing_group = [[CSDatabaseCache sharedInstance].groupDictionary objectForKey:self.identifier];
        if (existing_group != nil)
            return existing_group;
        else
            [[CSDatabaseCache sharedInstance].groupDictionary setObject:self forKey:self.identifier];

        _name = [TBXML textForElement:[TBXML childElementNamed:@"Name" parentElement:groupElement] withStringEncoding:NSUTF8StringEncoding];
        _name = [_name stringByReplacingOccurrencesOfString:@"&amp;" withString:@"&"];
        _name = [_name stringByDecodingHTMLEntities];
        
        TBXMLElement* websiteElement = [TBXML childElementNamed:@"Website" parentElement:groupElement];
        if (websiteElement != NULL)
            _website = [TBXML textForElement:websiteElement];
    }
    
    return self;
}


@end
