//
//  DiskImageViewController.m
//  C64SceneBrowser
//
//  Created by Andreas Varga on 05.04.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DiskImageViewController.h"
#import "libx64/vice/src/arch/unix/ios/cocoa_touch/vicemachine.h"


@implementation DiskImageViewController


// ----------------------------------------------------------------------------
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
// ----------------------------------------------------------------------------
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self)
    {
        // Custom initialization
        
        _mediaFiles = nil;
    }
    return self;
}


// ----------------------------------------------------------------------------
- (void)viewDidLoad
// ----------------------------------------------------------------------------
{
    [super viewDidLoad];
    
    _mediaFiles = [theVICEMachine mediaFiles];
    
	// Do any additional setup after loading the view.
}


// ----------------------------------------------------------------------------
- (void)viewDidUnload
// ----------------------------------------------------------------------------
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}


// ----------------------------------------------------------------------------
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
// ----------------------------------------------------------------------------
{
	return YES;
}



#pragma mark TableView delegate and datasource

// ----------------------------------------------------------------------------
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
// ----------------------------------------------------------------------------
{
    return 1;
}


// ----------------------------------------------------------------------------
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    if (_mediaFiles == nil)
        return 1;
    else
        return _mediaFiles.count;
}    


// ----------------------------------------------------------------------------
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:@"Cell"];
    
    if (_mediaFiles == nil || _mediaFiles.count == 0)
        cell.textLabel.text = @"No Disk/Tape Media to Select";
    else
    {
        cell.textLabel.text = [[_mediaFiles objectAtIndex:indexPath.row] lastPathComponent];
        if (indexPath.row == [theVICEMachine currentMediaFileIndex])
            cell.accessoryType = UITableViewCellAccessoryCheckmark;
        else
            cell.accessoryType = UITableViewCellAccessoryNone;
    }
        
    return cell;
}


// ----------------------------------------------------------------------------
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    return NO;
}


// ----------------------------------------------------------------------------
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    return @"";
}


// ----------------------------------------------------------------------------
- (NSIndexPath *)tableView:(UITableView *)tableView willSelectRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    if (_mediaFiles == nil)
        return nil;
    
    return indexPath;
}


// ----------------------------------------------------------------------------
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    if (_mediaFiles == nil)
        return;
    
    [theVICEMachine setCurrentMediaFileIndex:indexPath.row];
    
    [self.navigationController popViewControllerAnimated:YES];
}


@end
