//
//  MasterViewController.m
//  C64SceneBrowser
//
//  Created by Andreas Varga on 16.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MasterViewController.h"
#import "StartPageViewController.h"
#import "DetailViewController.h"
#import "CreditsViewController.h"
#import "ReleaseViewController.h"
#import "AppDelegate.h"


@implementation MasterViewController

@synthesize rightViewController = _rightViewController;


NSString* sOverviewURLs[OVERVIEWTYPE_COUNT] =
{
    @"http://csdb.dk/webservice/?type=latestrel",                               // LATEST_RELEASES
    @"http://csdb.dk/webservice/?type=latestadd&addtype=release",               // LATEST_ADDITIONS
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=1",           // TOP_DEMOS
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=2",           // TOP_ONE_FILE_DEMOS
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=3,4,18,36",   // TOP_INTROS
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=5",           // TOP_CRACK_INTROS
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=11",          // TOP_GAMES
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=9",           // TOP_GRAPHICS
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=10",          // TOP_GRAPHICS_COLLECTION
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=7",           // TOP_MUSIC
    @"http://csdb.dk/webservice/?type=chart&ctype=release&subtype=8",           // TOP_MUSIC_COLLECTION
    @"http://csdb.dk/latestcomments.php",                                       // RECENTLY_COMMENTED
    nil,                                                                        // RECENTLY_VIEWED
    nil,                                                                        // FAVORITES
    @"http://csdb.dk/webservice/?type=search&stype=release&q=%@"                // SEARCH
};


// ----------------------------------------------------------------------------
- (void) awakeFromNib
// ----------------------------------------------------------------------------
{
    self.clearsSelectionOnViewWillAppear = NO;
    //self.contentSizeForViewInPopover = CGSizeMake(320.0, 600.0);
    
    _categories = [NSMutableArray array];

    NSMutableArray* items = [NSMutableArray array];
    [items addObject:[[OverviewItem alloc] initWithType:LATEST_RELEASES andDescription:@"Latest Releases"  andURL:sOverviewURLs[LATEST_RELEASES] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:LATEST_ADDITIONS andDescription:@"Latest Additions" andURL:sOverviewURLs[LATEST_ADDITIONS] hasRange:YES isHTML:NO]];
    [_categories addObject:items];
    
    items = [NSMutableArray array];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_DEMOS andDescription:@"Top Demos" andURL:sOverviewURLs[TOP_DEMOS] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_ONE_FILE_DEMOS andDescription:@"Top One-File Demos" andURL:sOverviewURLs[TOP_ONE_FILE_DEMOS] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_INTROS andDescription:@"Top Intros" andURL:sOverviewURLs[TOP_INTROS] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_INTROS andDescription:@"Top Crack Intros" andURL:sOverviewURLs[TOP_CRACK_INTROS] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_GRAPHICS andDescription:@"Top Graphics" andURL:sOverviewURLs[TOP_GRAPHICS] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_GRAPHICS andDescription:@"Top Graphics Collections" andURL:sOverviewURLs[TOP_GRAPHICS_COLLECTION] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_GRAPHICS andDescription:@"Top Music" andURL:sOverviewURLs[TOP_MUSIC] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_GRAPHICS andDescription:@"Top Music Collections" andURL:sOverviewURLs[TOP_MUSIC_COLLECTION] hasRange:YES isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:TOP_GAMES andDescription:@"Top Games" andURL:sOverviewURLs[TOP_GAMES] hasRange:YES isHTML:NO]];
    [_categories addObject:items];
    
    items = [NSMutableArray array];
    [items addObject:[[OverviewItem alloc] initWithType:RECENTLY_VIEWED andDescription:@"Recently Viewed" andURL:sOverviewURLs[RECENTLY_VIEWED] hasRange:NO isHTML:NO]];
    [items addObject:[[OverviewItem alloc] initWithType:FAVORITES andDescription:@"Favorites" andURL:sOverviewURLs[FAVORITES] hasRange:NO isHTML:NO]];
    [_categories addObject:items];
    
    if (INTERFACE_IS_PAD)
    {
        UIBarButtonItem* rootBarButtonItem = [[UIBarButtonItem alloc] initWithTitle:@"C64 Scene" style:UIBarButtonItemStylePlain target:self action:@selector(showStartupPage)];
        NSMutableArray* toolbarItems = [NSMutableArray arrayWithObject:rootBarButtonItem];
        [self setToolbarItems:toolbarItems animated:YES];
    }
    
    [super awakeFromNib];
}


// ----------------------------------------------------------------------------
- (void) viewDidLoad
// ----------------------------------------------------------------------------
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    //self.navigationItem.leftBarButtonItem = self.editButtonItem;
    
    _rightViewController = (StartPageViewController *)[[self.splitViewController.viewControllers lastObject] topViewController];
    if (_rightViewController != nil)
        _rightViewController.title = @"Commodore 64 Scene";
    
    _selectedOverviewItem = nil;
}


// ----------------------------------------------------------------------------
- (void) viewDidUnload
// ----------------------------------------------------------------------------
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}


// ----------------------------------------------------------------------------
- (void) viewWillAppear:(BOOL) animated
// ----------------------------------------------------------------------------
{
    [self.tableView setContentOffset:CGPointMake(0.0f, 56.0f) animated:NO];
}


// ----------------------------------------------------------------------------
- (UIStatusBarStyle) preferredStatusBarStyle
// ----------------------------------------------------------------------------
{
    return UIStatusBarStyleLightContent;
}


// ----------------------------------------------------------------------------
- (BOOL) shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
// ----------------------------------------------------------------------------
{
    return YES;
}


// ----------------------------------------------------------------------------
- (void) startSearchWithText:(NSString*)searchText
// ----------------------------------------------------------------------------
{
    NSString* searchDescription = [NSString stringWithFormat:@"Search for \"%@\"", searchText];
    NSString* searchURL = [NSString stringWithFormat:sOverviewURLs[SEARCH], [searchText stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding]];
    
    OverviewItem* item = [[OverviewItem alloc] initWithType:SEARCH andDescription:searchDescription andURL:searchURL hasRange:YES isHTML:NO];
    [self showDetailViewOfOverviewItem:item];
}


// ----------------------------------------------------------------------------
- (void) showDetailViewOfOverviewItem:(OverviewItem*) item
// ----------------------------------------------------------------------------
{
    if (INTERFACE_IS_PHONE)
    {
        _selectedOverviewItem = item;
        [self performSegueWithIdentifier:@"ShowDetailView" sender:self];
    }
    else
    {
        // Prevent navigation to the same detail view that we're already showing
        if ([_rightViewController.navigationController.topViewController isKindOfClass:[DetailViewController class]] && _rightViewController.selectedOverviewItem == item)
            return;
        
        if ([_rightViewController.navigationController.topViewController isKindOfClass:[DetailViewController class]])
        {
            DetailViewController* detailViewController = (DetailViewController*)_rightViewController.navigationController.topViewController;
            if (detailViewController.isAppearing)
                return;
        }
        
        if ([_rightViewController.navigationController.topViewController isKindOfClass:[StartPageViewController class]])
        {
            StartPageViewController* startPageViewController = (StartPageViewController*)_rightViewController.navigationController.topViewController;
            if (startPageViewController.isAppearing)
                return;
        }
        
        _rightViewController.selectedOverviewItem = item;
        [_rightViewController performSegueWithIdentifier:@"ShowDetailView" sender:self];
    }
}


// ----------------------------------------------------------------------------
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
// ----------------------------------------------------------------------------
{
    if ([[segue identifier] isEqualToString:@"ShowCreditsDetail"])
    {
        ReleaseViewController* releaseViewController = (ReleaseViewController*) sender;
        CreditsViewController* creditsViewController = [segue destinationViewController];
        
        creditsViewController.releaseItem = releaseViewController.releaseItem;
        
        releaseViewController.creditsViewController = creditsViewController;
    }
    else if ([[segue identifier] isEqualToString:@"ShowDetailView"])
    {
        DetailViewController* detailViewController = [segue destinationViewController];
        detailViewController.overviewItem = _selectedOverviewItem;
        
        AppDelegate* appDelegate = (AppDelegate*)[[UIApplication sharedApplication] delegate];
        if (appDelegate.masterPopoverController != nil)
            [appDelegate.masterPopoverController dismissPopoverAnimated:YES];
    }

}


// ----------------------------------------------------------------------------
- (void) showStartupPage
// ----------------------------------------------------------------------------
{
    if ([_rightViewController.navigationController.topViewController isKindOfClass:[StartPageViewController class]])
        return;

    if (_rightViewController.navigationController.topViewController.isBeingPresented)
        return;
    
    [_rightViewController.navigationController popToRootViewControllerAnimated:YES];
}


#pragma mark - Table View


// ----------------------------------------------------------------------------
- (NSInteger) numberOfSectionsInTableView:(UITableView*) tableView
// ----------------------------------------------------------------------------
{
    if (INTERFACE_IS_PHONE)
        return _categories.count + 1;
        
    return _categories.count;
}


// ----------------------------------------------------------------------------
- (NSInteger) tableView:(UITableView*) tableView numberOfRowsInSection:(NSInteger) section
// ----------------------------------------------------------------------------
{
    if (INTERFACE_IS_PHONE && section == 0)
        return 1;

    if (INTERFACE_IS_PHONE)
        section--;
    
    return [[_categories objectAtIndex:section] count];
}


// ----------------------------------------------------------------------------
- (UITableViewCell*) tableView:(UITableView*) tableView cellForRowAtIndexPath:(NSIndexPath*) indexPath
// ----------------------------------------------------------------------------
{
    if (INTERFACE_IS_PHONE && indexPath.section == 0)
    {
        UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:@"TitleCell"];
        return cell;
    }

    UITableViewCell* cell = [tableView dequeueReusableCellWithIdentifier:@"Cell"];
    
    OverviewItem* item = [[_categories objectAtIndex:INTERFACE_IS_PHONE ? indexPath.section - 1 : indexPath.section] objectAtIndex:indexPath.row];
    cell.textLabel.text = item.description;
    cell.contentView.backgroundColor = ((indexPath.row & 1) == 0) ? [UIColor blackColor] : [UIColor colorWithWhite:0.1f alpha:1.0f];
    return cell;
}


// ----------------------------------------------------------------------------
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    return NO;
}


// ----------------------------------------------------------------------------
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    if (INTERFACE_IS_PHONE && indexPath.section == 0)
        return;

    OverviewItem* item = [[_categories objectAtIndex:INTERFACE_IS_PHONE ? indexPath.section - 1 : indexPath.section] objectAtIndex:indexPath.row];
    [self showDetailViewOfOverviewItem:item];
}


// ----------------------------------------------------------------------------
- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    switch (section)
    {
        case 0:
            return @"Recent Updates";
            break;
        case 1:
            return @"Charts";
            break;
        case 2:
            return @"Personal";
            break;
    }

    return @"";
}


// ----------------------------------------------------------------------------
- (CGFloat) tableView:(UITableView *)tableView heightForHeaderInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    if (INTERFACE_IS_PHONE && section == 0)
        return 0.0f;
    
    return 22.0f;
}


// ----------------------------------------------------------------------------
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
// ----------------------------------------------------------------------------
{
    if (INTERFACE_IS_PHONE)
    {
        if (indexPath.section == 0)
            return 80.0f;
    }
    
    return 44.0f;
}

// ----------------------------------------------------------------------------
- (UIView*) tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
// ----------------------------------------------------------------------------
{
    NSString *sectionTitle = [self tableView:tableView titleForHeaderInSection:INTERFACE_IS_PHONE ? section - 1 : section];
    if (sectionTitle == nil)
        return nil;

    if (INTERFACE_IS_PHONE && section == 0)
        sectionTitle = @"Test";

    CGFloat width = tableView.frame.size.width;
    
    UIView* customView = [[UIView alloc] init];
    customView.backgroundColor = [UIColor lightGrayColor]; //[UIColor colorWithPatternImage:[UIImage imageNamed:@"section_header"]];
    
    CGFloat left_inset = 15.0f;
    UILabel* headerLabel = [[UILabel alloc] initWithFrame:CGRectMake(left_inset, -23.0f, width - left_inset, 46.0f)];
    headerLabel.backgroundColor = [UIColor clearColor];
    headerLabel.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
    headerLabel.opaque = NO;
    headerLabel.textColor = [UIColor darkGrayColor];
    headerLabel.font = [UIFont boldSystemFontOfSize:14.0f];
    headerLabel.textAlignment = NSTextAlignmentLeft;
    headerLabel.text = sectionTitle;
    [customView addSubview:headerLabel];
    return customView;
}

 

#pragma mark UISearchBarDelegate


// ----------------------------------------------------------------------------
- (void)searchBarSearchButtonClicked:(UISearchBar*) searchBar
// ----------------------------------------------------------------------------
{
    if (!_isEditingSearch)
        return;

    _isEditingSearch = NO;
    
    [self startSearchWithText:searchBar.text];
    [searchBar resignFirstResponder];
}


// ----------------------------------------------------------------------------
- (void) searchBarTextDidBeginEditing:(UISearchBar*) searchBar
// ----------------------------------------------------------------------------
{
    _isEditingSearch = YES;
}

// ----------------------------------------------------------------------------
- (void)searchBarTextDidEndEditing:(UISearchBar*) searchBar
// ----------------------------------------------------------------------------
{
    if (!_isEditingSearch)
        return;
    
    _isEditingSearch = NO;
    [self startSearchWithText:searchBar.text];
}



@end



@implementation OverviewItem

@synthesize type = _type;
@synthesize description = _description;
@synthesize url = _url;
@synthesize hasRange = _hasRange;
@synthesize parseHTML = _parseHTML;


// ----------------------------------------------------------------------------
- (id) initWithType:(OverviewType)type andDescription:(NSString*)description andURL:(NSString*)url hasRange:(BOOL)hasRange isHTML:(BOOL)isHTML
// ----------------------------------------------------------------------------
{
    self = [super init];
    if (self)
    {
        _type = type;
        _description = description;
        _url = url;
        _hasRange = hasRange;
        _parseHTML = isHTML;
    }
    return self;
    
}


@end

