//
//  ReleaseViewController.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 19.03.12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "CSReleaseItem.h"
#import "OHAttributedLabel.h"
#import "CSDatabaseCache.h"

@class SSLoadingView;
@class MasterViewController;
@class CreditsViewController;
@class EmulationViewController;




@interface ReleaseViewController : UIViewController <CSDatabaseItemDelegate, CSReleaseViewerDelegate, CSScenerViewerDelegate, OHAttributedLabelDelegate, UIActionSheetDelegate, UIScrollViewDelegate>
{
    IBOutlet UILabel*               _titleLabel;
    IBOutlet UILabel*               _subtitleLabel;
    IBOutlet OHAttributedLabel*     _groupsLabel;
    IBOutlet UILabel*               _ratingLabel;
    IBOutlet UIImageView*           _screenshotImageView;
    IBOutlet UIView*                _ratingView;
    IBOutlet UIView*                _ratingOverlayView;
    IBOutlet UITableView*           _commentsTableView;
    IBOutlet UIButton*              _playButton;
    IBOutlet OHAttributedLabel*     _releasedAtLabel;
    IBOutlet OHAttributedLabel*     _achievementLabel;
    IBOutlet UIScrollView*          _scrollView;
    IBOutlet UIBarButtonItem*       _creditsButton;
    
    SSLoadingView*                  _commentsLoadingView;
    CSReleaseItem*                  _previousReleaseItem;
    BOOL                            _allImagesRequested;
    BOOL                            _allImagesLoaded;
    
    BOOL                            _allowDownload;

    UIScrollView*                   _imageScrollView;
    UIImageView*                    _zoomedScreenshotView;
    UIImageView*                    _origScreenshotView;
    
    UIActionSheet*                  _actionSheet;
    
    EmulationViewController*        _emulationViewController;
    
    UIPopoverController*            _downloadListPopOver;
}


- (IBAction) tapActionButton:(id)sender;
- (IBAction) openInSafari:(id)sender;
- (IBAction) addToFavorites:(id)sender;
- (IBAction) playRelease:(id)sender;
 
- (void) addMasterPopoverButton:(UIBarButtonItem*)barButtonItem;
- (void) removeMasterPopoverButton:(UIBarButtonItem*)barButtonItem;

@property (nonatomic) CSReleaseItem* releaseItem;
@property (nonatomic) BOOL isPresentingEmulationView;
@property (nonatomic) CreditsViewController* creditsViewController;
@property (nonatomic) NSUInteger selectedDownloadIndex;

@end


@interface CommentItemCell : UITableViewCell
{
}

@property (nonatomic) IBOutlet UILabel* handleLabel;
@property (nonatomic) IBOutlet UILabel* dateLabel;
@property (nonatomic) IBOutlet OHAttributedLabel* commentLabel;
@property (nonatomic) IBOutlet UIImageView* photoImageView;
@property (nonatomic) NSMutableArray* commentImageViews;

@end



@interface MainInfoItemCell : UITableViewCell
{
}

@property (nonatomic) IBOutlet UILabel* titleLabel;
@property (nonatomic) IBOutlet UILabel* subtitleLabel;
@property (nonatomic) IBOutlet OHAttributedLabel* groupsLabel;
@property (nonatomic) IBOutlet UILabel* ratingLabel;
@property (nonatomic) IBOutlet UIImageView* screenshotImageView;
@property (nonatomic) IBOutlet UIView* ratingView;
@property (nonatomic) IBOutlet UIView* ratingOverlayView;
@property (nonatomic) IBOutlet UIButton* playButton;
@property (nonatomic) IBOutlet OHAttributedLabel* releasedAtLabel;
@property (nonatomic) IBOutlet OHAttributedLabel* achievementLabel;


@end
