
/*
#ifdef GL_ES
precision highp float;
#endif

varying mediump vec2 coordinate; 
uniform lowp sampler2D videoframe;
uniform mediump vec2 screenSize;
*/
 
/*
void main()
{
    vec4 color = texture2D(videoframe, coordinate);
    //float odd = mod(coordinate.y * screenSize.y, 2.0);
    //gl_FragColor = color * vec4(odd, odd, odd, odd);
    gl_FragColor = color;
}
*/



/*
vec3 weight(float pixel)
{
    pixel = mod(pixel + 3.0, 3.0);
    if (pixel >= 2.0) // Blue
        return vec3(pixel - 2.0, 0.0, 3.0 - pixel);
    else if (pixel >= 1.0) // Green
        return vec3(0.0, 2.0 - pixel, pixel - 1.0);
    else // Red
        return vec3(1.0 - pixel, pixel, 0.0);
}

void main()
{
    lowp float y = mod(coordinate.y * screenSize.y/2.0, 1.0);
    lowp float intensity = exp(-0.2 * y);

    vec2 one_x = vec2(1.0 / (3.0 * screenSize.x/2.0), 0.0);

    lowp vec3 color = texture2D(videoframe, coordinate.xy - 0.0 * one_x).rgb;
    lowp vec3 color_prev = texture2D(videoframe, coordinate.xy - 1.0 * one_x).rgb;
    lowp vec3 color_prev_prev = texture2D(videoframe, coordinate.xy - 2.0 * one_x).rgb;

    float pixel_x = 3.0 * coordinate.x * screenSize.x/2.0;

    lowp vec3 weight_this = weight(pixel_x - 0.0);
    lowp vec3 weight_prev = weight(pixel_x - 1.0);
    lowp vec3 weight_prev_prev = weight(pixel_x - 2.0);

    vec3 result =
        0.8 * color * weight_this +
        0.6 * color_prev * weight_prev +
        0.3 * color_prev_prev * weight_prev_prev;

    result = 2.3 * pow(result, vec3(1.4));

    gl_FragColor = vec4(intensity * result, 1.0);
}

*/





















//#pragma parameter MASK_BRIGHTNESS "Mask brightness" 0.70 0.0 1.0 0.01
//#pragma parameter SCANLINE_WEIGHT "Scanline weight" 6.0 0.0 15.0 0.1
//#pragma parameter SCANLINE_GAP_BRIGHTNESS "Scanline gap brightness" 0.12 0.0 1.0 0.01
//#pragma parameter BLOOM_FACTOR "Bloom factor" 1.5 0.0 5.0 0.01

// Haven't put these as parameters as it would slow the code down.
#define SCANLINES
#define MULTISAMPLE
// MASK_TYPE: 0 = none, 1 = green/magenta, 2 = trinitron(ish)
#define MASK_TYPE 1

#define MASK_BRIGHTNESS 0.70
#define SCANLINE_WEIGHT 6.0
#define SCANLINE_GAP_BRIGHTNESS 0.12
#define BLOOM_FACTOR 1.5

/* COMPATIBILITY
 - GLSL compilers
 */

/*
 crt-pi - A Raspberry Pi friendly CRT shader.
 
 Copyright (C) 2015-2016 davej
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the Free
 Software Foundation; either version 2 of the License, or (at your option)
 any later version.
 
 
 Notes:
 
 This shader is designed to work well on Raspberry Pi GPUs (i.e. 1080P @ 60Hz on a game with a 4:3 aspect ratio). It pushes the Pi's GPU hard and enabling some features will slow it down so that it is no longer able to match 1080P @ 60Hz. You will need to overclock your Pi to the fastest setting in raspi-config to get the best results from this shader: 'Pi2' for Pi2 and 'Turbo' for original Pi and Pi Zero. Note: Pi2s are slower at running the shader than other Pis, this seems to be down to Pi2s lower maximum memory speed. Pi2s don't quite manage 1080P @ 60Hz - they drop about 1 in 1000 frames. You probably won't notice this, but if you do, try enabling FAKE_GAMMA.
 
 SCANLINES enables scanlines. You'll almost certainly want to use it with MULTISAMPLE to reduce moire effects. SCANLINE_WEIGHT defines how wide scanlines are (it is an inverse value so a higher number = thinner lines). SCANLINE_GAP_BRIGHTNESS defines how dark the gaps between the scan lines are. Darker gaps between scan lines make moire effects more likely.
 
 GAMMA enables gamma correction using the values in INPUT_GAMMA and OUTPUT_GAMMA. FAKE_GAMMA causes it to ignore the values in INPUT_GAMMA and OUTPUT_GAMMA and approximate gamma correction in a way which is faster than true gamma whilst still looking better than having none. You must have GAMMA defined to enable FAKE_GAMMA.
 
 By default the shader uses linear blending horizontally. If you find this too blury, enable SHARPER.
 
 BLOOM_FACTOR controls the increase in width for bright scanlines.
 
 MASK_TYPE defines what, if any, shadow mask to use. MASK_BRIGHTNESS defines how much the mask type darkens the screen.
 
 */

#ifdef GL_ES
#define COMPAT_PRECISION mediump
#else
#define COMPAT_PRECISION
#endif

//uniform COMPAT_PRECISION vec2 screenSize;
//varying COMPAT_PRECISION vec2 coordinate;
//varying COMPAT_PRECISION float filterWidth;


varying mediump vec2 coordinate;
uniform lowp sampler2D videoframe;
uniform mediump vec2 screenSize;


#define filterWidth (1.0/3.0)


COMPAT_PRECISION float CalcScanLineWeight(COMPAT_PRECISION float dist)
{
    return max(1.0-dist*dist*SCANLINE_WEIGHT, SCANLINE_GAP_BRIGHTNESS);
}

COMPAT_PRECISION float CalcScanLine(COMPAT_PRECISION float dy)
{
    COMPAT_PRECISION float scanLineWeight = CalcScanLineWeight(dy);
#if defined(MULTISAMPLE)
    scanLineWeight += CalcScanLineWeight(dy-filterWidth);
    scanLineWeight += CalcScanLineWeight(dy+filterWidth);
    scanLineWeight *= 0.3333333;
#endif
    return scanLineWeight;
}

void main()
{
    COMPAT_PRECISION vec2 texcoord = coordinate;
    {
        COMPAT_PRECISION vec2 texcoordInPixels = texcoord * screenSize;
        COMPAT_PRECISION float tempY = floor(texcoordInPixels.y) + 0.5;
        COMPAT_PRECISION float yCoord = tempY / screenSize.y;
        COMPAT_PRECISION float dy = texcoordInPixels.y - tempY;
        COMPAT_PRECISION float scanLineWeight = CalcScanLine(dy);
        COMPAT_PRECISION float signY = sign(dy);
        dy = dy * dy;
        dy = dy * dy;
        dy *= 8.0;
        dy /= screenSize.y;
        dy *= signY;
        COMPAT_PRECISION vec2 tc = vec2(texcoord.x, yCoord + dy);
        
        COMPAT_PRECISION vec3 colour = texture2D(videoframe, tc).rgb;
        
#if defined(SCANLINES)
        scanLineWeight *= BLOOM_FACTOR;
        colour *= scanLineWeight;
#endif

#if MASK_TYPE == 0
        gl_FragColor = vec4(colour, 1.0);
#else
#if MASK_TYPE == 1
        COMPAT_PRECISION float whichMask = fract(gl_FragCoord.x * 0.5);
        COMPAT_PRECISION vec3 mask;
        if (whichMask < 0.5)
            mask = vec3(MASK_BRIGHTNESS, 1.0, MASK_BRIGHTNESS);
        else
            mask = vec3(1.0, MASK_BRIGHTNESS, 1.0);
#elif MASK_TYPE == 2
        COMPAT_PRECISION float whichMask = fract(gl_FragCoord.x * 0.3333333);
        COMPAT_PRECISION vec3 mask = vec3(MASK_BRIGHTNESS, MASK_BRIGHTNESS, MASK_BRIGHTNESS);
        if (whichMask < 0.3333333)
            mask.x = 1.0;
        else if (whichMask < 0.6666666)
            mask.y = 1.0;
        else
            mask.z = 1.0;
#endif
        
        gl_FragColor = vec4(colour * mask, 1.0);
#endif
    }
}
