//
//  StartPageViewController.h
//  C64SceneBrowser
//
//  Created by Andreas Varga on 07.07.12.
//
//

#import <UIKit/UIKit.h>
#import "CSReleaseItem.h"
#import "ReleaseViewController.h"
#import "ScenerViewController.h"

@class OverviewItem;
@class OHAttributedLabel;
@class FeaturedComment;
@class SSLoadingView;


@interface StartPageViewController : UIViewController <CSDatabaseItemDelegate, CSReleaseViewerDelegate, CSScenerViewerDelegate, UIScrollViewDelegate>
{
    IBOutlet UIScrollView*          _scrollView;
    IBOutlet UIPageControl*         _pageControl;
    
    IBOutlet UILabel*               _newsItemLabel;
    
    SSLoadingView*                  _loadingView;

    NSURLConnection*                _sceneNewsUrlConnection;
    NSMutableData*                  _sceneNewsData;
    NSMutableArray*                 _sceneNewsItems;
    NSTimer*                        _newsItemFadeTimer;
    NSInteger                       _nextNewsItemIndex;

    NSURLConnection*                _commentsUrlConnection;
    NSMutableData*                  _commentsData;
    NSMutableArray*                 _commentItems;
    NSMutableArray*                 _commentImageViews;
    
    BOOL                            _pageControlBeingUsed;
}

@property (nonatomic) OverviewItem* selectedOverviewItem;
@property (nonatomic) BOOL isAppearing;


- (IBAction) changePage;
- (IBAction) refresh:(id)sender;

@end


@interface FeaturedComment : NSObject
{
    
}

@property (nonatomic) NSString* title;
@property (nonatomic) NSString* author;
@property (nonatomic) NSString* date;
@property (nonatomic) NSString* description;
@property (nonatomic) CSReleaseItem* releaseItem;

@end